#include <stdio.h>
#include <stdlib.h>
#include <SDL.h>
#include "global.h"
#include "inputs.h"


void get_inputs(S_Input *Sinput)
{/*lecture des entres et rduction aux besoins du jeu*/

    SDL_Event event;

    while (SDL_PollEvent(&event))
    {
        switch (event.type)
        {
            /**clavier**/
            case SDL_KEYDOWN :
                Sinput->key[event.key.keysym.sym]=TRUE;
            break;

            case SDL_KEYUP :
                Sinput->key[event.key.keysym.sym]=FALSE;
            break;

            /**souris**/

            case SDL_MOUSEBUTTONDOWN :
                Sinput->Smouse.mseBt[event.button.button]=TRUE;
            break;

            case SDL_MOUSEBUTTONUP :
                Sinput->Smouse.mseBt[event.button.button]=FALSE;
            break;

            case SDL_MOUSEMOTION :
                Sinput->Smouse.msePos[0]=event.motion.x;
                Sinput->Smouse.msePos[1]=event.motion.y;
            break;

            /**pads**/

            case SDL_JOYBUTTONDOWN :
                Sinput->Spad[event.jbutton.which].padBT[event.jbutton.button]=TRUE;
            break;

            case SDL_JOYBUTTONUP :
                Sinput->Spad[event.jbutton.which].padBT[event.jbutton.button]=FALSE;
            break;

            case SDL_JOYHATMOTION :
                Sinput->Spad[event.jhat.which].padHat=event.jhat.value;
            break;

            case SDL_JOYAXISMOTION :
                Sinput->Spad[event.jaxis.which].stickPos[event.jaxis.axis]=(event.jaxis.value);
            break;

            /**divers**/

            case SDL_QUIT :
                Sinput->quit=TRUE;
            break;

            default:
            break;
        }
    }
}


void init_inputs(S_Input* Sinput)
{/*initialisation de la structure des entres*/

    int i=0;/*variable de boucle*/
    int j=0;/*variable de boucle 2*/
    int nbPad=SDL_NumJoysticks();/*nombre de pad branchs*/

    Sinput->nbPad=nbPad;

    Sinput->Smouse.msePos[0]=0;
    Sinput->Smouse.msePos[1]=0;

    if (nbPad>0)
    {/*si pads prsents*/



        for(i=0;i<nbPad;i++)
        {/*init des structures S_pad*/

            Sinput->Spad[i].padHat=0;

            for(j=0;j<15;j++)
            {
                Sinput->Spad[i].padBT[j]=FALSE;

                if (j<2)
                    Sinput->Spad[i].stickPos[j]=0;
            }
        }
        Sinput->Spad->plageMorte=2000;
    }


    Sinput->quit=FALSE;

    for (i=0;i<SDLK_LAST;i++)
    {/*initialisation des touches et boutons souris*/
        Sinput->key[i]=FALSE;

        if (i<10)
            Sinput->Smouse.mseBt[i]=FALSE;
    }
}


int mouse_box(S_Input *Sinput, SDL_Rect* boites,int nombre)
{/*retourne l'index de la boite sur laquelle est la souris ou -2 ***valide***/

    int retour=FUNC_ERR;
    int i=0;

    if (boites!=NULL)
    {
        for(i=0;i<nombre;i++)
        {
            if ((Sinput->Smouse.msePos[0]>=boites[i].x)
                && (Sinput->Smouse.msePos[0]<(boites[i].x+boites[i].w))
                && (Sinput->Smouse.msePos[1]>=boites[i].y)
                && (Sinput->Smouse.msePos[1]<(boites[i].y+boites[i].h)))

                retour=i;
        }
    }

    return(retour);
}
