#include <stdlib.h>
#include <stdio.h>
#include <SDL.h>
#include <SDL_image.h>
#include <SDL_TTF.h>
#include "module_init.h"
#include "global.h"
#include "inputs.h"


int main(int argc, char* argv[])
{
    (void) argc;
    (void) argv;

    /*****DECLARATIONS*****/

    BOOL fin=FALSE,
        leftClicMemo=FALSE;

    char texte[2][20]={"\0","\0"},/*deux lignes de texte*/
        lettre;/*lettre en cours*/

    int lettreEnCours=0,/*lettre en cours*/
        ligneEnCours=0,/*ligne en cours*/
        i=0;/*variable de boucle*/

    SDL_Rect mseBox[28],/*les mouse box*/
            rosettePos,/*pierre de rosette*/
            ligneUnePos,/*position de la ligne une*/
            ligneDeuxPos;/*position de la ligne deux*/

    SDL_Surface* rosette=NULL,/*le pierre de rosette*/
                *ecran=NULL,/*cran principal*/
                *ligneUne=NULL,/*premiere ligne de texte*/
                *ligneDeux=NULL;/*deuxime ligne de texte*/

    S_Input Sinput;/*structure des entres*/

    TTF_Font* police=NULL;/*police utilise*/

    SDL_Color couleur;


    /*****PRELIMINAIRE*****/

    couleur.r=255;
    couleur.b=255;
    couleur.g=255;

    init_inputs(&Sinput);

    if (init_modules()!=FUNC_OK)/*initialisation des modules*/
        fin=TRUE;


    /**ecran d'affichage**/

    if ((ecran=SDL_SetVideoMode(LARGEUR,HAUTEUR,32,SDL_HWSURFACE | SDL_DOUBLEBUF))==NULL)
    {/*si pas d'ecran*/
        fprintf(stderr,"Err main : Erreur de cration de la surface principale d'affichage.\nL'application est arrte...");
        fin=TRUE;
    }

    /**pierre de rosette**/

    if ((rosette=IMG_Load("pierre.png"))==NULL)
    {/*la pierre de rosette*/
        fprintf(stderr,"Err main : chargement de pierre.png");
        fin=TRUE;
    }
    else
    {/*on dfini la position*/
        rosettePos.x=0;
        rosettePos.y=0;
        rosettePos.h=rosette->h;
        rosettePos.w=rosette->w;
    }

    /**chargement de la police**/

    if (!fin && ((police=TTF_OpenFont("MetalMacabre.ttf",20))==NULL))
    {
        fprintf(stderr,"Err menu_jeu : chargement de la police impossible.\n");
        fin=TRUE;/*on n'effectue pas la boucle principale*/
    }

    /**position des textes**/

    ligneUnePos.x=0;
    ligneUnePos.y=100;
    ligneDeuxPos.x=0;
    ligneDeuxPos.y=125;

    /**init des mouse box**/

    for(i=0;i<28;i++)
    {
        if (i<14)
        {
            mseBox[i].x=40*i;
            mseBox[i].y=0;
            mseBox[i].h=50;
            mseBox[i].w=40;
        }
        else
        {
            mseBox[i].x=40*(i-14);
            mseBox[i].y=50;
            mseBox[i].h=50;
            mseBox[i].w=40;
        }
    }

    while(!fin)
    {

        get_inputs(&Sinput);

        if ((lettre=mouse_box(&Sinput,mseBox,28))>=0 && re(Sinput.Smouse.mseBt[SDL_BUTTON_LEFT],&leftClicMemo))
        {
            if (lettre<26)
            {/*une lettre*/

                texte[ligneEnCours][lettreEnCours]=(lettre+'a');
                texte[ligneEnCours][lettreEnCours+1]='\0';
                add_modulo(INC,&lettreEnCours,18);

                /**changement de ligne**/
                if (lettreEnCours==18 && !ligneEnCours)
                    add_modulo(INC,&ligneEnCours,1);
            }
            else if (lettre==26)
            {/*retour chariot*/

                if (lettreEnCours>0)
                    add_modulo(DEC,&lettreEnCours,18);

                else if(!lettreEnCours && ligneEnCours)
                {
                    ligneEnCours=0;
                    lettreEnCours=18;
                }

                texte[ligneEnCours][lettreEnCours]='\0';
            }
            else if (lettre==27)
            {/*delete all*/
                texte[0][0]='\0';
                texte[1][0]='\0';
                ligneEnCours=0;
                lettreEnCours=0;
            }
        }

        if (Sinput.quit)
            fin=TRUE;


        ligneUne=TTF_RenderText_Solid(police, texte[0], couleur);
        ligneDeux=TTF_RenderText_Solid(police, texte[1], couleur);

        if (ligneUne!=NULL)
            ligneUnePos.x=(LARGEUR-ligneUne->w)/2;

        if(ligneDeux!=NULL)
            ligneDeuxPos.x=(LARGEUR-ligneDeux->w)/2;


        SDL_FillRect(ecran,NULL,SDL_MapRGB(ecran->format,0,0,0));
        SDL_BlitSurface(rosette,NULL,ecran,&rosettePos);
        SDL_BlitSurface(ligneUne,NULL,ecran,&ligneUnePos);
        SDL_BlitSurface(ligneDeux,NULL,ecran,&ligneDeuxPos);

        SDL_FreeSurface(ligneUne);
        SDL_FreeSurface(ligneDeux);

        SDL_Flip(ecran);

        SDL_Delay(1000/FPS);

    }

    SDL_FreeSurface(rosette);
    SDL_FreeSurface(ecran);
    TTF_CloseFont(police);

    quit_modules();


    return(0);
}
